<template>
  <div :class="{ 'is-subscribed': aboArea && userSubscribed }">
    <client-only>
      <CookieBanner />
    </client-only>
    <header class="site-header" :class="{ on: menuOn }">
      <div class="site-header-wrapper">
        <div class="site-header_left">
          <a
            href="#"
            class="icon icon-burger site-header_menu-mobile-button"
            @click.prevent.stop="toggleMenu"
          ></a>

          <section class="site-header_logo">
            <a
              :href="homeUrlForCurrentArea"
              @click.prevent="
                gtmEvent('Header', 'Logo', 'logo_', true, homeUrlForCurrentArea)
              "
            >
              <img
                v-if="aboArea && userSubscribed"
                :src="require('~/assets/images/izneo-logo-white.svg')"
                alt="izneo logo"
              />
              <img
                v-else
                :src="require('~/assets/images/izneo-logo.svg')"
                alt="izneo logo"
              />
            </a>
            <span
              v-if="$i18n.locale !== 'fr' && userSubscribed && aboArea"
              class="site-header_logo_baseline"
              >{{ $t('header.aboArea') }}</span
            >
            <span
              v-else-if="$i18n.locale !== 'fr' && userLogged"
              class="site-header_logo_baseline"
            >
              {{ $t('header.storeArea') }}
            </span>
          </section>

          <nav class="site-header_menu" :class="{ on: menuOn }">
            <ul>
              <li class="menu-item-only-desktop">
                <a
                  :href="homeUrlForCurrentArea"
                  class="home-ico"
                  :class="{ on: currentRouteIsHome }"
                  @click.prevent="hideMenu"
                >
                  <svg
                    xmlns="http://www.w3.org/2000/svg"
                    width="20"
                    height="20"
                    viewBox="0 0 20 20"
                  >
                    <g fill="none" fill-rule="evenodd">
                      <g :fill="aboArea ? '#fff' : '#000'" fill-rule="nonzero">
                        <path
                          d="M83.1 2667.685l-8-5.38c-.7-.407-1.5-.407-2.2 0l-8 5.38c-.6.305-.9 1.016-.9 1.625v10.66c0 1.116.9 2.03 2 2.03h16c1.1 0 2-.914 2-2.03v-10.66c0-.61-.3-1.32-.9-1.625zM72 2679.97v-4.061c0-1.117.9-2.03 2-2.03s2 .913 2 2.03v4.06h-4zm6 0v-4.061c0-2.234-1.8-4.061-4-4.061s-4 1.827-4 4.06v4.062h-4v-10.66l8-5.381 8 5.38v10.66h-4z"
                          transform="translate(-64 -2662)"
                        />
                      </g>
                    </g>
                  </svg>
                </a>
              </li>
              <li class="menu-item-only-mobile">
                <a
                  :href="homeUrlForCurrentArea"
                  :class="{ on: currentRouteIsHome }"
                  @click.prevent="hideMenu"
                >
                  {{ $t('header.home') }}
                </a>
              </li>

              <li
                class="has-submenu"
                :class="{ open: subMenuShelves }"
                @click="subMenuShelves = !subMenuShelves"
              >
                <a href="#" :class="{ on: currentRouteIsCatalog }">
                  {{ $t('breadcrumb.catalog') }}
                </a>
                <nav class="site-header_submenu">
                  <ul>
                    <li
                      v-for="(shelfToDisplay, i) in shelvesToDisplay"
                      :key="i"
                    >
                      <a
                        :href="`${host}/${$i18n.locale}${
                          aboArea ? '/abo' : ''
                        }/${shelfToDisplay.slug}`"
                      >
                        {{ shelfToDisplay.title }}
                      </a>
                    </li>
                  </ul>
                </nav>
              </li>
              <li v-if="$i18n.locale === 'fr'">
                <a
                  :href="universeUrlForCurrentArea"
                  :class="{ on: currentRouteIsUniverse }"
                  @click.prevent="universeClick"
                  >{{ $t('breadcrumb.universe') }}</a
                >
              </li>

              <template v-if="!userLogged">
                <li v-if="['de', 'nl', 'it'].indexOf($i18n.locale) === -1">
                  <a
                    :href="subscriptionUrl"
                    :class="{ on: currentRouteIsSubscription }"
                    @click.prevent="
                      gtmEvent(
                        'Header',
                        'Abonnement',
                        'abonnement_',
                        true,
                        subscriptionUrl
                      )
                    "
                  >
                    {{ $t('header.subscription') }}
                  </a>
                </li>
                <li class="site-header_item-mobile">
                  <a
                    :href="signupUrl"
                    @click.prevent="
                      gtmEvent(
                        'Header',
                        'Inscription',
                        'inscription_',
                        true,
                        signupUrl
                      )
                    "
                  >
                    {{ $t('header.signup') }}
                  </a>
                </li>
                <li class="site-header_item-mobile">
                  <a
                    :href="`${host}/${$i18n.locale}/login`"
                    @click.prevent="
                      gtmEvent(
                        'Header',
                        'Connexion',
                        'connexion_',
                        true,
                        `${host}/${$i18n.locale}/login`
                      )
                    "
                  >
                    {{ $t('header.login') }}
                  </a>
                </li>
              </template>

              <template v-else>
                <AdminLinks v-if="userIsAdmin" :lang="userLanguage" />

                <li v-if="userSubscribed" class="site-header_item-mobile">
                  <a
                    :href="switchStoreAboAreaUrl"
                    @click.prevent="
                      gtmEvent(
                        'Header',
                        storeArea ? 'Espace-abonne' : 'Acces-boutique',
                        storeArea ? 'espace_' : 'boutique_',
                        true,
                        switchStoreAboAreaUrl
                      )
                    "
                  >
                    {{ switchStoreAboAreaText }}
                  </a>
                </li>
                <li
                  v-else-if="['de', 'nl', 'it'].indexOf($i18n.locale) === -1"
                  class="site-header_item-mobile site-header_item-mobile--color"
                >
                  <a
                    :href="subscriptionUrl"
                    @click.prevent="
                      gtmEvent(
                        'Header',
                        'Abonnement',
                        'abonnement_',
                        true,
                        subscriptionUrl
                      )
                    "
                    >{{ $t('header.subscribe') }}</a
                  >
                </li>

                <li
                  v-if="userLanguage !== 'nl'"
                  class="site-header_item-mobile has-submenu"
                  :class="{ open: communityOn }"
                >
                  <a
                    href="#"
                    :class="{ on: currentRouteIsCommunity }"
                    @click.prevent.stop="toggleCommunity"
                    >{{ $t('header.my_community') }}</a
                  >

                  <nav class="site-header_submenu">
                    <ul>
                      <li
                        v-for="communityLink in communityLinks"
                        :key="communityLink.name"
                      >
                        <a :href="getCommunityUrl(communityLink.url)">{{
                          $t(communityLink.text)
                        }}</a>
                      </li>
                    </ul>
                  </nav>
                </li>

                <li class="site-header_item-mobile">
                  <a :href="wishlistUrl">{{ $t('header.myWishlist') }}</a>
                </li>

                <li
                  class="site-header_item-mobile has-submenu"
                  :class="{ open: settingsOn }"
                >
                  <a
                    href="#"
                    :class="{ on: currentRouteIsSettings }"
                    @click.prevent.stop="toggleSettings"
                    >{{ $t('header.parameters') }}</a
                  >
                  <nav class="site-header_submenu">
                    <ul>
                      <li
                        v-for="settingsLink in settingsLinks"
                        :key="settingsLink.name"
                      >
                        <a
                          v-if="settingsLink.name !== 'logout'"
                          :href="getSettingsUrl(settingsLink.url)"
                          >{{ $t(settingsLink.text) }}</a
                        >
                        <a
                          v-else
                          class="button button_md button_shape_grey"
                          :href="getSettingsUrl(settingsLink.url)"
                          @click="logout"
                          >{{ $t(settingsLink.text) }}</a
                        >
                      </li>
                    </ul>
                  </nav>
                </li>
              </template>
            </ul>
          </nav>

          <Search :lang="userLanguage" :abo="userSubscribed && aboArea" />
        </div>

        <div class="site-header_right">
          <template v-if="!userLogged">
            <span
              class="button button_md button_full role-link"
              @click.prevent="
                gtmEvent(
                  'Header',
                  'Inscription',
                  'inscription_',
                  true,
                  signupUrl
                )
              "
              >{{ $t('header.signup') }}</span
            >
            <span
              class="button button_md button_full_grey role-link"
              @click.prevent="
                gtmEvent(
                  'Header',
                  'Connexion',
                  'connexion_',
                  true,
                  `${host}/${$i18n.locale}/login`
                )
              "
              >{{ $t('header.login') }}</span
            >
            <span
              class="icon icon-cart icon-cart-not-empty role-link"
              :data-cart="cartItemCount"
              style="margin-right: 10px"
              @click="cartClick"
            ></span>

            <HeaderLangSwitcher />
          </template>

          <template v-else>
            <a
              v-if="userSubscribed"
              :href="switchStoreAboAreaUrl"
              :class="[
                'button button_md',
                storeArea ? 'button_blue' : 'button_orange'
              ]"
              @click.prevent="
                gtmEvent(
                  'Header',
                  storeArea ? 'Espace-abonne' : 'Acces-boutique',
                  storeArea ? 'espace_' : 'boutique_',
                  true,
                  switchStoreAboAreaUrl
                )
              "
              >{{ switchStoreAboAreaText }}</a
            >
            <a
              v-else-if="['de', 'nl', 'it'].indexOf($i18n.locale) === -1"
              :href="subscriptionUrl"
              class="button button_md button_blue"
              @click.prevent="
                gtmEvent(
                  'Header',
                  'Abonnement',
                  'abonnement_',
                  true,
                  subscriptionUrl
                )
              "
              >{{ $t('header.subscribe') }}</a
            >

            <div v-if="userLanguage !== 'nl'" class="has-submenu">
              <a href="#" class="icon icon-user-following"></a>
              <nav class="site-header_submenu">
                <ul>
                  <li
                    v-for="communityLink in communityLinks"
                    :key="communityLink.name"
                  >
                    <a :href="getCommunityUrl(communityLink.url)">{{
                      $t(communityLink.text)
                    }}</a>
                  </li>
                </ul>
              </nav>
            </div>

            <a :href="wishlistUrl" class="icon icon-like"></a>
            <a
              :href="cartUrl"
              class="icon icon-cart icon-cart-not-empty"
              :data-cart="cartItemCount"
            ></a>
            <a
              :href="libraryUrl"
              class="icon icon-library"
              @click.prevent="
                gtmEvent(
                  'Header',
                  'Bibliotheque',
                  'bibliotheque_',
                  true,
                  libraryUrl
                )
              "
            ></a>
            <a :href="settingsUrl" class="icon icon-setting"></a>
          </template>
        </div>
      </div>
    </header>
  </div>
</template>

<script>
import AdminLinks from '~/components/AdminLinks'
import Search from '~/components/ui/Search'
import HeaderLangSwitcher from '~/components/ui/HeaderLangSwitcher'
import CookieBanner from '~/components/ui/CookieBanner'

/*
  required data in api response:
    - user native language (to create main nav URLs)
    - user subscription
    - cart: item count
  */

const communityLinks = [
  {
    name: 'newsfeed',
    url: 'newsfeed',
    text: 'header.newsfeed_newsfeed'
  },
  {
    name: 'find_followers',
    url: 'followers',
    text: 'header.newsfeed_followers'
  },
  {
    name: 'find_followees',
    url: 'followees',
    text: 'header.newsfeed_following'
  },
  {
    name: 'discover',
    url: 'discover',
    text: 'header.newsfeed_discover'
  },
  {
    name: 'profil_edit',
    url: 'profil/edit',
    text: 'header.profile_edit'
  }
]

const settingsLinks = [
  {
    name: 'account',
    url: '/settings/account',
    text: 'settings.account.title'
  },
  {
    name: 'methods',
    url: '/settings/methods',
    text: 'settings.methods.title'
  },
  {
    name: 'configuration',
    url: '/settings/configuration',
    text: 'settings.configuration.title'
  },
  {
    name: 'logout',
    url: '/logout',
    urlParams: {},
    text: 'settings.logout'
  }
]

export default {
  name: 'PageHeader',
  components: { AdminLinks, Search, HeaderLangSwitcher, CookieBanner },
  data() {
    return {
      communityLinks: communityLinks,
      settingsLinks: settingsLinks,
      menuOn: false,
      subMenuShelves: false,
      settingsOn: false,
      communityOn: false
    }
  },

  computed: {
    currentRouteName() {
      return this.$nuxt.$route.name ? this.$nuxt.$route.name : ''
    },
    ui() {
      return this.$store.state.auth &&
        this.$store.state.auth.loggedIn &&
        this.$store.state.auth.user
        ? this.$store.state.auth.user
        : {}
    },
    userLogged() {
      return this.$store.state.auth && this.$store.state.auth.loggedIn
    },
    userSubscribed() {
      return 'hasActiveClassicSubscription' in this.ui
        ? this.ui.hasActiveClassicSubscription
        : false
    },
    userIsAdmin() {
      return this.userHasRole('ADMIN')
    },
    userIsGhost() {
      return 'isGhost' in this.ui ? this.ui.isGhost : false
    },
    cartItemCount() {
      return 'cartItemCount' in this.ui
        ? this.ui.cartItemCount
        : this.$store.state.cartItemCount
    },
    userLanguage() {
      return this.$i18n.locale
    },
    aboArea() {
      return this.$utils.aboArea()
    },
    storeArea() {
      return !this.aboArea
    },
    homeUrl() {
      return this.$utils.homeUrlForLang(this.userLanguage)
    },
    homeAboUrl() {
      return this.$utils.homeAboUrlForLang(this.userLanguage)
    },
    currentRouteIsHome() {
      return this.currentRouteName.indexOf('home') === 0
    },
    currentRouteIsCatalog() {
      // TODO this won't work, this.currentRouteName is like 'catalog___fr'
      return ['catalog', 'catalogAbo'].indexOf(this.currentRouteName) >= 0
    },
    currentRouteIsUniverse() {
      return this.currentRouteName.indexOf('universe') >= 0
    },
    currentRouteIsSubscription() {
      return this.currentRouteName.indexOf('subscription___') === 0
    },
    currentRouteIsCommunity() {
      const links = communityLinks.map((v) => v.name)
      return links.indexOf(this.currentRouteName) >= 0
    },
    currentRouteIsSettings() {
      // TODO this won't work, this.$route.name is like 'settings___fr'
      return ['settings', 'settingsAbo'].indexOf(this.$route.name) >= 0
    },
    userHasWebtoonAbo() {
      if (
        !this.userLogged ||
        !this.userSubscribed ||
        !this.ui.subscriptions ||
        !this.ui.subscriptions.length
      )
        return false
      return (
        this.ui.subscriptions.filter(
          (v) => v.name.toLowerCase().indexOf('webtoon') >= 0
        ).length > 0
      )
    },
    shelvesToDisplay() {
      const shelfKeys = {
        fr: ['bd', 'mangas', 'webtoon', 'comics', 'graphic-novel'],
        en: ['bd', 'mangas', 'webtoon', 'comics', 'graphic-novel'],
        de: ['bd', 'mangas', 'comics', 'graphic-novel'],
        nl: ['bd', 'comics', 'graphic-novel'],
        it: ['bd', 'mangas', 'comics', 'graphic-novel']
      }
      if (this.userHasWebtoonAbo && this.aboArea) {
        return [
          {
            title: this.$t(`shelves.webtoon.title`),
            slug: this.$t(`shelves.webtoon.slug`)
          }
        ]
      } else {
        return shelfKeys[this.$i18n.locale].map((v) => ({
          title: this.$t(`shelves.${v}.title`),
          slug: this.$t(`shelves.${v}.slug`)
        }))
      }
    },
    switchStoreAboAreaUrl() {
      return this.storeArea ? this.homeAboUrl : this.homeUrl
    },
    homeUrlForCurrentArea() {
      return this.storeArea ? this.homeUrl : this.homeAboUrl
    },
    universeUrlForCurrentArea() {
      return this.storeArea
        ? this.$utils.universeUrlForLang(this.$i18n.locale)
        : this.$utils.universeAboUrlForLang(this.$i18n.locale)
    },
    switchStoreAboAreaText() {
      return this.storeArea
        ? this.$t('header.aboArea')
        : this.$t('header.switchToStoreArea')
    },
    subscriptionUrl() {
      const path = this.userLanguage === 'fr' ? 'abonnement' : 'subscription'
      return `${this.host}/${this.userLanguage}/${path}`
    },
    signupUrl() {
      const path = this.userLanguage === 'fr' ? 'inscription' : 'signup'
      return `${this.host}/${this.userLanguage}/${path}`
    },
    settingsUrl() {
      const path = this.userIsGhost
        ? 'signup-ghost'
        : (this.userSubscribed && this.aboArea ? 'abo/' : '') +
          'settings/account'
      return `${this.host}/${this.userLanguage}/${path}`
    },
    cartUrl() {
      const path = this.userLanguage === 'fr' ? 'panier' : 'shopping-cart'
      return `${this.host}/${this.userLanguage}/${
        this.aboArea ? 'abo/' : ''
      }${path}`
    },
    wishlistUrl() {
      return `${this.host}/${this.userLanguage}/${
        this.aboArea ? 'abo/' : ''
      }wishlist`
    },
    libraryUrl() {
      const path = this.userLanguage === 'fr' ? 'bibliotheque' : 'library'
      return `${this.host}/${this.userLanguage}/${
        this.aboArea ? 'abo/' : ''
      }${path}`
    },
    host() {
      return this.$config.izneoUrl
    }
  },

  methods: {
    hideMenu() {
      this.menuOn = false
      document.body.classList.remove('no-scroll')

      this.$utils.gtmEvent(
        {
          event: 'gtm.event',
          EventCategory: 'Header',
          EventAction: 'Accueil',
          EventLabel: `accueil_${window.location.href.replace(
            window.location.origin,
            ''
          )}`
        },
        this.homeUrlForCurrentArea
      )
    },
    universeClick() {
      this.menuOn = false
      document.body.classList.remove('no-scroll')

      this.$utils.gtmEvent(
        {
          event: 'gtm.event',
          EventCategory: 'Header',
          EventAction: 'Univers',
          EventLabel: `univers_${window.location.href.replace(
            window.location.origin,
            ''
          )}`
        },
        this.universeUrlForCurrentArea
      )
    },
    toggleMenu() {
      this.menuOn = !this.menuOn
      // "head.bodyAttrs" seems to work too, but this method is simpler
      document.body.classList.toggle('no-scroll')
    },
    toggleSettings() {
      this.settingsOn = !this.settingsOn
    },
    toggleCommunity() {
      this.communityOn = !this.communityOn
    },
    generateLocalizedUrl(lang, routeName, routeParams) {
      return this.localePath({
        name: routeName,
        params: {
          ...routeParams,
          lang
        }
      })
    },
    getCommunityUrl(url) {
      return `${this.host}/${this.userLanguage}/${
        this.userSubscribed && this.aboArea ? 'abo/' : ''
      }${url}`
    },
    getSettingsUrl(url) {
      return `${this.host}/${this.userLanguage}${
        this.userSubscribed && this.aboArea ? '/abo' : ''
      }${url}`
    },
    userHasRole(role) {
      if ('roles' in this.ui) {
        return this.ui.roles.indexOf(role) >= 0
      }
      return false
    },
    async logout() {
      await this.$store.dispatch('doLogout')
    },

    gtmEvent(category, action, label, addCurrentUrl, redirectUrl) {
      this.$utils.gtmEvent(
        {
          event: 'gtm.event',
          EventCategory: category,
          EventAction: action,
          EventLabel: `${label}${
            addCurrentUrl
              ? window.location.href.replace(window.location.origin, '')
              : ''
          }`
        },
        redirectUrl
      )
    },
    cartClick() {
      window.location.href = this.cartUrl
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/layouts/header/_header.scss"
></style>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/heading/_heading.scss"
></style>

<style lang="scss" scoped>
.role-link {
  cursor: pointer;
}

.menu-item {
  &-only-mobile {
    display: none !important;
  }
  &-only-desktop {
    display: flex !important;
  }

  @media (max-width: 1259px) {
    &-only-mobile {
      display: block !important;
    }

    &-only-desktop {
      display: none !important;
    }
  }
}

.home-ico {
  position: relative;
  top: -2px;
}
</style>
